---
#######################################################################
#                                                                     #
#   Create helper resources.                                          #
#   Includes IAM and Lambda resources                                 #
#                                                                     #
#######################################################################
- name: "stack | set-unique-hostname | debug | params"
  tags: [ "aws", "lambda", "lambda:setuniquehostname", "aws:lambda:setuniquehostname", "lambda:setuniquehostname:deploy", "aws:lambda:setuniquehostname:deploy", "lambda:setuniquehostname:deploy", "aws:lambda:setuniquehostname:deploy" ]
  debug: var=params
  when: aws_lambda_setuniquehostname_params.debug

- name: "stack | set-unique-hostname | set_fact | cftags_lambda_setuniquehostname"
  tags: [ "aws", "lambda", "lambda:setuniquehostname", "aws:lambda:setuniquehostname", "lambda:setuniquehostname:deploy", "aws:lambda:setuniquehostname:deploy", "lambda:setuniquehostname:deploy", "aws:lambda:setuniquehostname:deploy" ]
  set_fact:
    cftags_lambda_setuniquehostname: "{{ cftags_lambda_setuniquehostname | default({}) | combine({tag_prefix + ':' + item.key: item.value}) | combine(cloudformation_tags | default({})) }}"
  with_dict:
    owner           : "{{ owner }}"
    environment     : "{{ environment_type }}"
    environment_abbr: "{{ environment_abbr }}"
    account         : "{{ account_name }}"
    role            : "lambda"

- name: "stack | set-unique-hostname | cloudformation | deploy"
  tags: [ "aws", "lambda", "lambda:setuniquehostname", "aws:lambda:setuniquehostname", "lambda:setuniquehostname:deploy", "aws:lambda:setuniquehostname:deploy", "lambda:setuniquehostname:deploy", "aws:lambda:setuniquehostname:deploy" ]
  cloudformation:
    state              : present
    template           : "{{ lambda_role_path + '/files/cf-lambda.yaml' }}"
    create_changeset   : "{{ aws_lambda_setuniquehostname_params.create_changeset }}"
    stack_name         : "{{ lambda_stack_prefix }}-setuniquehostname"
    region             : "{{ aws_region }}"
    tags               : "{{ cftags_lambda_setuniquehostname }}"
    template_parameters:
      TagPrefix    : "{{ tag_prefix }}"
      S3Bucket     : "{{ aws_lambda_setuniquehostname_params.lambda_bucket_name }}"
      S3Path       : "{{ lambda_s3key[aws_lambda_setuniquehostname_params.lambda.name] }}"
      Concurrency  : "{{ lambda_set_unique_hostname_concurrency }}"
      LogExpiration: "{{ aws_lambda_setuniquehostname_params.log_expiration | default(lambda_log_expiration) | int }}"

- name: "stack | set-unique-hostname | debug | register"
  tags: [ "aws", "lambda", "lambda:setuniquehostname", "aws:lambda:setuniquehostname", "lambda:setuniquehostname:deploy", "aws:lambda:setuniquehostname:deploy", "lambda:setuniquehostname:deploy", "aws:lambda:setuniquehostname:deploy" ]
  cloudformation_facts:
    stack_name: "{{ lambda_stack_prefix }}-setuniquehostname"
  register: result
  when: aws_lambda_setuniquehostname_params.debug

- name: "stack | set-unique-hostname | debug | print"
  tags: [ "aws", "lambda", "lambda:setuniquehostname", "aws:lambda:setuniquehostname", "lambda:setuniquehostname:deploy", "aws:lambda:setuniquehostname:deploy", "lambda:setuniquehostname:deploy", "aws:lambda:setuniquehostname:deploy" ]
  debug: var=result.ansible_facts.cloudformation[lambda_stack_prefix+'-setuniquehostname']
  when: aws_lambda_setuniquehostname_params.debug
